//
//  MuteConversationActivity.swift
//  Tusker
//
//  Created by Shadowfacts on 5/14/20.
//  Copyright © 2020 Shadowfacts. All rights reserved.
//

import UIKit
import Pachyderm

class MuteConversationActivity: StatusActivity {
    override var activityType: UIActivity.ActivityType? {
        return .muteConversation
    }
    
    override var activityTitle: String? {
        return NSLocalizedString("Mute Conversation", comment: "mute conversation activity title")
    }
    
    override var activityImage: UIImage? {
        return UIImage(systemName: "speaker.slash")
    }
    
    override func perform() {
        guard let status = status else { return }
        
        let request = Status.muteConversation(status.id)
        mastodonController.run(request) { (response) in
            if case let .success(status, _) = response {
                self.mastodonController.persistentContainer.addOrUpdate(status: status)
            } else {
                // todo: display error message
                UINotificationFeedbackGenerator().notificationOccurred(.error)
                fatalError()
            }
        }
    }

}
