//
//  SavedHashtag.swift
//  Tusker
//
//  Created by Shadowfacts on 5/8/22.
//  Copyright © 2022 Shadowfacts. All rights reserved.
//

import Foundation
import CoreData
import Pachyderm
import WebURLFoundationExtras

@objc(SavedHashtag)
public final class SavedHashtag: NSManagedObject {
    
    @nonobjc public class func fetchRequest() -> NSFetchRequest<SavedHashtag> {
        return NSFetchRequest<SavedHashtag>(entityName: "SavedHashtag")
    }
    
    @nonobjc public class func fetchRequest(name: String) -> NSFetchRequest<SavedHashtag> {
        let req = NSFetchRequest<SavedHashtag>(entityName: "SavedHashtag")
        req.predicate = NSPredicate(format: "name = %@", name)
        return req
    }
    
    @NSManaged public var name: String
    @NSManaged public var url: URL
    
}

extension SavedHashtag {
    convenience init(hashtag: Hashtag, context: NSManagedObjectContext) {
        self.init(context: context)
        self.name = hashtag.name
        self.url = URL(hashtag.url)!
    }
}
